<HTML>
<HEAD>
<!-- This HTML file has been created by texi2html 1.54
     from suif1.texi on 28 April 1999 -->

<TITLE>The SUIF Version 1 Library - Procedure Level</TITLE>
<link href="suif1_4.html" rel=Next>
<link href="suif1_2.html" rel=Previous>
<link href="suif1_toc.html" rel=ToC>

</HEAD>
<BODY>
<p>Go to the <A HREF="suif1_1.html">first</A>, <A HREF="suif1_2.html">previous</A>, <A HREF="suif1_4.html">next</A>, <A HREF="suif1_113.html">last</A> section, <A HREF="suif1_toc.html">table of contents</A>.
<P><HR><P>


<H2><A NAME="SEC3" HREF="suif1_toc.html#TOC3">The Procedure Level</A></H2>
<P>
<A NAME="IDX3"></A>
<A NAME="IDX4"></A>

</P>
<P>
Because SUIF is used in a wide variety of projects, the representation
of procedure bodies includes both high-level and low-level information.
In the first stages of a compilation, the high-level structure is
represented by a language-independent form of abstract syntax trees
(ASTs).  This format, which we call <STRONG>high-SUIF</STRONG>, is well-suited for
passes such as dependence analysis and loop transformation that need the
high-level structure of the code.  Later in the compilation process, the
ASTs are reduced to sequential lists of instructions.  This form, which
we call <STRONG>low-SUIF</STRONG>, works well for some scalar optimizations and for
code generation.  Note that SUIF still has only one intermediate
representation; high-SUIF and low-SUIF are both implemented with the
same tree data structures.  See section <A HREF="suif1_10.html#SEC10">Abstract Syntax Trees</A>.  They only differ in the
amount of high-level information present.  As long as a SUIF pass does
not depend on particular features of high-SUIF or low-SUIF, it can
handle either format.  High-SUIF and low-SUIF may also be mixed together
within the same procedure.

</P>
<P>
The leaf nodes of an AST are <STRONG>instruction nodes</STRONG>.  See section <A HREF="suif1_14.html#SEC14">Instruction Nodes</A>.  Each of these nodes contains a single instruction or expression
tree.  In low-SUIF code, a procedure body is reduced to a list of
instruction nodes containing individual instructions.  This form
resembles the quadruple representation used by traditional scalar
optimizers.

</P>
<P>
<STRONG>Block nodes</STRONG> represent nested scopes.  See section <A HREF="suif1_18.html#SEC18">Block Nodes</A>.  A block
node contains a symbol table and a list of the AST nodes within the
block.  The scope of the symbols and types defined in the symbol table
is restricted to the AST nodes within the block.  They cannot be
referenced from outside the block.  The root node of an AST is a special
kind of block node called a <STRONG>procedure node</STRONG>.  Except for some extra
methods and a slightly different kind of symbol table, a procedure node
is the same as a block node.

</P>
<P>
Conditional structures may be represented by <STRONG>if nodes</STRONG>.  See section <A HREF="suif1_15.html#SEC15">If Nodes</A>.  An "if" node has three parts, each of which is a list of AST
nodes.  The <STRONG>header</STRONG> list contains code to evaluate the condition
and either branch to the <STRONG>else</STRONG> list or fall through to the
<STRONG>then</STRONG> list.  Because the header can contain control flow, it is
easy to implement short-circuit evaluation of conditional expressions.

</P>
<P>
SUIF has two different kinds of loops.  Many optimizations only apply to
certain well-behaved types of loops, so <STRONG>for nodes</STRONG> are provided for
loops with scalar indices that vary from their initial to final values,
being incremented or decremented on every iteration, and that meet
various other requirements.  Most Fortran <CODE>DO</CODE> loops qualify as
"for" nodes.  Loops that do not meet those requirements are
represented by <STRONG>loop nodes</STRONG>, which just record the control-flow
structure of the loops and are used to represent generic "do-while"
loops.

</P>
<P>
A loop node contains two lists of AST nodes.  See section <A HREF="suif1_16.html#SEC16">Loop Nodes</A>.  The
<STRONG>body</STRONG> list comes first and holds the loop body.  The <STRONG>test</STRONG>
list contains code to evaluate the "while" expression and
conditionally branch back to the beginning of the <CODE>body</CODE> list.  The
body may contain branches to the <CODE>continue</CODE> and <CODE>break</CODE>
labels, which are implicitly located at the beginning of the <CODE>test</CODE>
list and the end of the loop, respectively.

</P>
<P>
A "for" node is by far the most complicated type of AST node.  Besides
the loop body, it must specify the index variable and the range of
values for the index.  The lower bound, upper bound, and step operands
are expressions that are evaluated once at the beginning of the loop.
The index variable is initially assigned the value of the lower bound
and then incremented by the value of the step operand on every iteration
until it reaches the upper bound; the code to do this is automatically
created when the "for" node is expanded to low-SUIF code.  The "for"
node must also specify the comparison operator used to determine when
the index variable has reached the upper bound value.  The optional
<CODE>landing_pad</CODE> part is a list of nodes to be executed once at the
beginning of the loop; this provides a place to move loop-invariant
code.  As with loop nodes, the <CODE>body</CODE> list may contain branches to
the <CODE>continue</CODE> and <CODE>break</CODE> labels.

</P>

<P><HR><P>
<p>Go to the <A HREF="suif1_1.html">first</A>, <A HREF="suif1_2.html">previous</A>, <A HREF="suif1_4.html">next</A>, <A HREF="suif1_113.html">last</A> section, <A HREF="suif1_toc.html">table of contents</A>.
</BODY>
</HTML>
